Imports System.IO
Imports PersistData.DataSet1

Public Class frmPersistData

   Private _Datafile As New FileInfo("Dataset1.xml")

   Private Sub MenuStrip1_MenuClicked(ByVal Sender As Object, ByVal e As EventArgs) _
         Handles SaveToolStripMenuItem.Click, ReloadToolStripMenuItem.Click, TestToolStripMenuItem.Click
      Select Case True
         Case Sender Is SaveToolStripMenuItem
            Save()
         Case Sender Is ReloadToolStripMenuItem
            Reload()
         Case Sender Is TestToolStripMenuItem
            CalculateTimeSpan()
      End Select
   End Sub

   Private Sub CalculateTimeSpan()
      'ein Beispiel, wie auf typisierte Daten zugreifen und verarbeiten
      Dim tb = DataSet1.DataTable1
      If tb.Rows.Count < 1 Then
         MsgBox("aus einer leeren DataTable kann keine Zeitspanne ermittelt wern")
         Return
      End If
      Dim min = tb.First, max = min
      For Each rw In tb
         If rw.ADateTime < min.ADateTime Then
            min = rw
         ElseIf rw.ADateTime > max.ADateTime Then
            max = rw
         End If
      Next
      Dim tspan = max.ADateTime.Subtract(min.ADateTime)
      Dim sTime = String.Format("{0} Tage, {1} Stunden, {2} Minuten, {3} Sekunden", _
         tspan.Days, tspan.Hours, tspan.Minutes, tspan.Seconds)
      MsgBox(String.Join(Environment.NewLine, {"Die maximale Zeitspanne betrgt:", _
         sTime, "und liegt zwischen", min.Text & " und " & max.Text}))
   End Sub

   Private Sub Reload()
      DataSet1.Clear()
      If _Datafile.Exists Then
         DataSet1.ReadXml(_Datafile.FullName)
      Else
         MsgBox(String.Join(Environment.NewLine, {"kein Datafile gefunden:", _
            _Datafile.FullName, "", "Sie fahren mit leerem Dataset fort"}))
      End If
   End Sub

   Private Sub Save()
      Me.Validate()
      DataSet1.WriteXml(_Datafile.FullName)
   End Sub

   Private Sub frmPersistData_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
      Reload()
   End Sub

   'Korrektur eines WinForm-Bugs
   Private Sub Me_FormClosed(ByVal sender As Object, ByVal e As FormClosedEventArgs) Handles Me.FormClosed
      Me.Validate() 'nochn Bug: DGV kriegt beim Disposen einen ZeilenIndex-Fehler, wenns sich die ZufgeZeile im Edit-Modus befindet
      Me.SuspendLayout()
      With Me.Controls
         'Controls knnten sich theor. auch gegenseitig disposen, ber Events. dieses hier disposed ganz sicher immer das letzte Element was noch da ist
         While .Count > 0 : .Item(.Count - 1).Dispose() : End While
      End With
   End Sub
End Class